%% ExAdComp3
% ver. 3.08
% Excess adiabatic compressibility of ternary mixtures
% Dodatkov adiabatick kompresibilita ternrnch sms

clear all, close all, clc
global nbin nter
nfig = 0;


%% Language selection (1 - Czech 2 - English)
%  Volba jazyka (1 - etina, 2 - anglitina)
jazyk = menu('Jazyk nabdek a obrzk / Language of menus and figures',...
    'etina / Czech','Anglitina / English');
close(gcf)

%% Reading input data from MS Excel workbook
%  ten vstupnch dat z tabulky MS Excel
switch jazyk
    case 1
        disp(' Vstupn datov soubor')
        disp(' *********************')
    case 2
        disp(' Input data file')
        disp(' ***************')
end
disp(' ')
switch jazyk
    case 1
        datsoubor = input(' Zadejte jmno datovho souboru: ','s');
    case 2
        datsoubor = input(' Enter the name of the data file: ','s');
end
[pathstr, name, ext] = fileparts(datsoubor);
if strcmp(ext,'')
    datsoubor = [datsoubor,'.xls'];
else
    if ~strcmp(ext,'.xls')
        datsoubor = strrep(datsoubor,ext,'.xls');
    end
end
disp(' ')
fid = fopen(datsoubor);
if fid < 0
    disp(' ')
    switch jazyk
        case 1
            disp(['Soubor ',datsoubor,' v pracovn sloce neexistuje!!!'])
        case 2
            disp(['The file ',datsoubor,' does not exists in ', ...
                'the working folder!!!'])
    end
    disp(' ')
    return
elseif fid >= 3
    disp(' ')
    switch jazyk
        case 1
            disp([' Datov soubor ',datsoubor,' byl spn oteven!!!'])
        case 2
            disp([' Data file ',datsoubor,' was successfully opened!!!'])
    end
end
disp(' ')
fclose(fid);

switch jazyk
    case 1
        disp(' ten vstupnch dat')
        disp(' *******************')
    case 2
        disp(' Reading input data')
        disp(' ******************')
end
disp(' ')

% Reading names of mixture components
% ten nzv sloek smsi
switch jazyk
    case 1
        SheetName1 = 'Konstanty';
        SheetName2 = 'Data';
        SheetName3 = 'Vsledky';
        SheetName4 = 'Koeficienty';
    case 2
        SheetName1 = 'Constants';
        SheetName2 = 'Data';
        SheetName3 = 'Results';
        SheetName4 = 'Coefficients';
end
[nodata,compname,alldata] = xlsread(datsoubor,SheetName1,'A2:C2');
if isempty(compname)
    switch jazyk
        case 1
            disp([' Datov soubor ', datsoubor, ' neobsahuje jmna sloek!!!'])
        case 2
            disp([' Data file ', datsoubor, ' does not contain' , ...
                'components names!!!'])
    end
    disp(' ')
    return
end

if mean(size(compname) == size(1:3)) == 1 & ...
        mean(cell2mat(compname) == cell2mat(alldata)) == 1
    switch jazyk
        case 1
            disp([' Jmna t sloek spn petena!!!'])
        case 2
            disp([' Names of three components successfully read!!!'])
    end
    for k = 1:3
        switch jazyk
            case 1
                disp([' ', num2str(k), '. sloka: ', ...
                    cell2mat(compname(k))])
            case 2
                disp([' ', num2str(k), '. component: ', ...
                    cell2mat(compname(k))])
        end
    end
else
    switch jazyk
        case 1
            disp([' Chybn ten jmen sloek!!!'])
        case 2
            disp([' Wrong reading of components names !!!'])
    end
end

% Reading molar masses of pure components
% Dimension of molar masses: g/mol
% ten molrnch hmotnost istch sloek
% Rozmr molrnch hmotnost: g/mol
[molmass,nodata,alldata] = xlsread(datsoubor,SheetName1,'A5:C5');
disp(' ')
if isempty(molmass)
    switch jazyk
        case 1
            disp([' Datov soubor ', datsoubor, ...
                ' neobsahuje molrn hmotnosti sloek!!!'])
        case 2
            disp([' Data file ', datsoubor, ...
                ' does not contain molar masses of components!!!'])
    end
    disp(' ')
    return
end
if mean(size(molmass) == size(1:3)) == 1 & ...
        mean(molmass == cell2mat(alldata)) == 1
    switch jazyk
        case 1
            disp([' Molrn hmotnosti t sloek spn peteny!!!'])
        case 2
            disp([' Molar masses of three components successfully read!!!'])
    end
    for k = 1:3
        switch jazyk
            case 1
                disp([' Molrn hmotnost ',num2str(k),'. sloky: ', ...
                    num2str(molmass(k)), ' g/mol'])
            case 2
                disp([' Molar mass of ',num2str(k),'. component: ', ...
                    num2str(molmass(k)), ' g/mol'])
        end
        
    end
else
    switch jazyk
        case 1
            disp([' Chybn ten molrnch hmotnost sloek!!!'])
        case 2
            disp([' Wrong reading of components molar masses!!!'])
    end
end

% Conversion to SI units
% Pepoet jednotek do SI
molmassSI = 0.001*molmass;

% Reading densities of pure components
% Dimension of density: g/cm^3
% ten hustot istch sloek
% Rozmr hustot: g/cm^3
[density,nodata,alldata] = xlsread(datsoubor,SheetName1,'A9:C9');
disp(' ')
if isempty(density)
    switch jazyk
        case 1
            disp([' Datov soubor ', datsoubor, ' neobsahuje ', ...
                'hustoty sloek!!!'])
        case 2
            disp([' Data file ', datsoubor, ' does not contain ', ...
                'components densities!!!'])
    end
    disp(' ')
    return
end
if mean(size(density) == size(1:3)) == 1 & ...
        mean(density == cell2mat(alldata)) == 1
    switch jazyk
        case 1
            disp([' Hustoty t sloek spn peteny!!!'])
        case 2
            disp([' Densities of three components successfully read!!!'])
    end
    for k = 1:3
        switch jazyk
            case 1
                disp([' Hustota ',num2str(k),'. sloky: ', ...
                    num2str(density(k)), ' g/cm^3'])
            case 2
                disp([' Density of ',num2str(k),'. component: ', ...
                    num2str(density(k)), ' g/cm^3'])
        end
    end
else
    switch jazyk
        case 1
            disp([' Chybn ten hustot sloek!!!'])
        case 2
            disp([' Wrong reading of components densities!!!'])
    end
end

% Conversion to SI units
% Pepoet jednotek na SI
densitySI = 1000*density;

% Reading molar heat capacities of pure components
% Dimension of density: J/K/mol
% ten molrnch tepelnch kapacit istch sloek
% Rozmr molrnch tepelnch kapacit: J/K/mol
[heatcap,nodata,alldata] = xlsread(datsoubor,SheetName1,'A13:C13');
disp(' ')
if isempty(heatcap)
    switch jazyk
        case 1
            disp([' Datov soubor ', datsoubor, ' neobsahuje ', ...
                'molrn tepeln kapacity!!!'])
        case 2
            disp([' Data file ', datsoubor, ' does not contain ', ...
                'molar heat capacities of components!!!'])
    end
    disp(' ')
    return
end
if mean(size(heatcap) == size(1:3)) == 1 & ...
        mean(heatcap == cell2mat(alldata)) == 1
    switch jazyk
        case 1
            disp([' Molrn tepeln kapacity t sloek ', ...
                'spn peteny!!!'])
        case 2
            disp([' Molar heat capacities of three components ', ...
                'successfully read!!!'])
    end
    for k = 1:3
        switch jazyk
            case 1
                disp([' Molrn tepeln kapacita ',num2str(k), ...
                    '. sloky: ', num2str(heatcap(k)), ' J/K/mol'])
            case 2
                disp([' Molar heat capacity of ',num2str(k), ...
                    '. component: ', num2str(heatcap(k)), ' J/K/mol'])
        end
    end
else
    switch jazyk
        case 1
            disp([' Chybn ten molrnch tepelnch kapacit sloek!!!'])
        case 2
            disp([' Wrong reading of molar heat capacities ', ...
                'of components!!!'])
    end
end

% Reading coefficients of thermal expansion of pure components
% Dimension of thermal expansion coeficients: 1/K
% ten koeficient tepeln roztanosti
% Rozmr koeficient tepeln roztanosti: 1/K
[thermexp,nodata,alldata] = xlsread(datsoubor,SheetName1,'A17:C17');
disp(' ')
if isempty(thermexp)
    switch jazyk
        case 1
            disp([' Datov soubor ', datsoubor, ' neobsahuje ', ...
                'koeficienty tepeln roztanosti!!!'])
        case 2
            disp([' Data file ', datsoubor, ' does not contain ', ...
                'thermal expansivity coefficients of components!!!'])
    end
    disp(' ')
    return
end
if mean(size(thermexp) == size(1:3)) == 1 & ...
        mean(thermexp == cell2mat(alldata)) == 1
    switch jazyk
        case 1
            disp([' Koeficienty tepeln roztanosti t sloek ', ...
                'spn peteny!!!'])
        case 2
            disp([' Thermal expansivity coefficients of three ', ...
                'components successfully read!!!'])
    end
    for k = 1:3
        switch jazyk
            case 1
                disp([' Koeficient tepeln roztanosti ',num2str(k), ...
                    '. sloky: ', num2str(thermexp(k)), ' 1/K'])
            case 2
                disp([' Thermal expansivity coefficient of ', ...
                    num2str(k),'. component: ', num2str(thermexp(k)), ' 1/K'])
        end
    end
else
    switch jazyk
        case 1
            disp([' Chybn ten koeficient tepeln roztaitelnosti ', ...
                'sloek!!!'])
        case 2
            disp([' Wrong reading of thermal expansivity ', ...
                'coefficients of components!!!'])
    end
end

% Reading temperature of measurement
% Dimension of temperature: K
% ten teploty men
% Rozmr teploty: K
[temp,nodata,alldata] = xlsread(datsoubor,'Data','E1');
disp(' ')
if isempty(temp)
    switch jazyk
        case 1
            disp([' Datov soubor ', datsoubor, ' neobsahuje ' ...
                'teplotu men!!!'])
        case 2
            disp([' Data file ', datsoubor, ' does not contain ' ...
                'measurement temperature!!!'])
    end
    disp(' ')
    return
end
if mean(size(temp) == size(1:1)) == 1 & ...
        temp == cell2mat(alldata)
    switch jazyk
        case 1
            disp([' Teplota men spn petena!!!'])
            disp([' Teplota men: ',num2str(temp), ' K'])
        case 2
            disp([' Measurement temperature successfully read!!!'])
            disp([' Measurement temperature: ',num2str(temp), ' K'])
    end
else
    switch jazyk
        case 1
            disp([' Chybn ten teploty men!!!'])
        case 2
            disp([' Wrong reading of measurement temperature!!!'])
    end
end

% Reading experimental data
% data: x1, x2, x3, density, speed of sound
% Dimension of mole fractions: 1
% Dimension of density: g/cm^3
% Dimension of speed of sound: m/s
% ten experimentlnch dat
% data: x1, x2, x3, hustota, rychlost zvuku
% Rozmr molrnch zlomk: 1
% Rozmr hustoty: g/cm^3
% Rozmr rychlosti zvuku: m/s
disp(' ')
[data,nodata,alldata] = xlsread(datsoubor,'Data','A5:E200');
if isempty(data)
    switch jazyk
        case 1
            disp([' Datov soubor ', datsoubor, ' neobsahuje men ', ...
                'data!!!'])
        case 2
            disp([' Data file ', datsoubor, ' does not contain ', ...
                'measuread data!!!'])
    end
    disp(' ')
    return
end

Nx = length(data);
if length(nodata) == 0 & isfloat(data) == 1
    switch jazyk
        case 1
            disp([' Namen hodnoty hustoty a rychlosti zvuku ', ...
                'v ternrnch smsch spn peteny!!!'])
            disp([' Peteno ',num2str(Nx),' namench bod!!!'])
        case 2
            disp([' Measured values of density and speed of sound ', ...
                'in ternary mixtures successfully read!!!'])
            disp([' ',num2str(Nx),' measured points read!!!'])
    end
else
    switch jazyk
        case 1
            disp([' Chybn ten mench hodnot!!!'])
        case 2
            disp([' Wrong reading of measured values!!!'])
    end
end

xx = data(:,1:3);
xdens = data(:,4);
xspeed = data(:,5);

%% Normalisation of mole fractions
%  Normalizace molrnch zlomk
switch jazyk
    case 1
        k = menu('Vyber zpsob normalizace molrnch zlomk', ...
            'Normalizace vech zlomk vydlenm jejich soutem', ...
            'Normalizace prvnch dvou zlomk a dopoet tetho');
    case 2
        k = menu('Select method of mole fractions normalization', ...
            'Normalization of all fractions dividing by their sum', ...
            ['Normalization of the first two fractions and calculation ', ...
            'of the third one']);
end
close(gcf);
sumxx = sum(xx(:,1:3),2);
xx(:,1) = xx(:,1)./sumxx;
xx(:,2) = xx(:,2)./sumxx;
switch k
    case 1
        xx(:,3) = xx(:,3)./sumxx;
    case 2
        xx(:,3) = 1-sum(xx(:,1:2),2);
end

%% Elimination of duplicate data
%  values of duplicate data items are replaced with their average
%  Odstrann duplicitnch dat
%  hodnoty u duplicitnch daj jsou nahrazeny prmrem hodnot
x = unique(xx,'rows');
N = length(x);
for k = 1:N
    dens(k,1) = mean(xdens(xx(:,1) == x(k,1) & xx(:,2) == x(k,2) & ...
        xx(:,3) == x(k,3)));
    speed(k,1) = mean(xspeed(xx(:,1) == x(k,1) & xx(:,2) == x(k,2) & ...
        xx(:,3) == x(k,3)));
end

x1 = x(:,1);
x2 = x(:,2);
x3 = x(:,3);

% Conversion to SI units
% Pepoet jednotek na SI
densSI = 1000*dens;

%% Writing measured data
%  Zpis mench dat
disp(' ')
switch jazyk
    case 1
        disp(' Zpis experimentlnch dat')
        disp(' **************************')
        disp(' ')
        disp(' Probh zpis dat do vstupn tabulky MS Excel!!!')
        disp(' ekejte, zpis dat me trvat nkolik destek vtein!!!')
    case 2
        disp(' Writing experimental data')
        disp(' *************************')
        disp(' ')
        disp(' Writing data to output MS Excel tables!!!')
        disp(' Wait, data writing may take tens of seconds!!!')
end
disp(' ')
warning off MATLAB:xlswrite:AddSheet
switch jazyk
    case 1
        [status, message] = xlswrite(datsoubor, ...
            {cell2mat(compname(1)), cell2mat(compname(2)), ...
             cell2mat(compname(3)), ...
            'Teplota', temp, '', ''; 
            'Molrn zlomky', '', '', 'Hustota', 'Rychlost zvuku', ...
            'Dodatkov adiabatick kompresibilita', ...
            'Dodatkov adiabatick kompresibilita'; ...
            'x1', 'x2', 'x3', 'r', 'u', 'kappaES exp', 'kappa ES RKe' ; ...
            '-', '-', '-', 'g/cm3', 'm/s', '1/TPa', '1/TPa'}, ...
            SheetName3,'A1');
    case 2
        [status, message] = xlswrite(datsoubor, ...
            {cell2mat(compname(1)), cell2mat(compname(2)), ...
             cell2mat(compname(3)), ...
            'Temperature', temp, '', ''; ...
            'Mole fractions', '', '', 'Density', 'Speed of sound', ...
            'Excess adiabatic compressibility', ...
            'Excess adiabatic compressibility'; ...
            'x1', 'x2', 'x3', 'r', 'u', 'kappaES exp', 'kappa ES RKe' ; ...
            '-', '-', '-', 'g/cm3', 'm/s', '1/TPa', '1/TPa'}, ...
            SheetName3,'A1');
end
if strcmp(message.message,'Added specified worksheet.')
    switch jazyk
        case 1
            disp([' Do souboru ', datsoubor, ' pidn list Vsledky!!!'])
        case 2
            disp([' Results worksheet added into file ', datsoubor, ...
                ' !!!'])
    end
    disp(' ')
end
[status, message] = xlswrite(datsoubor, [x1, x2, x3, dens, speed], ...
    SheetName3, 'A5');
if status == 1
    switch jazyk
        case 1
            disp([' Do souboru ', datsoubor, ' spn zapsno ', ...
                num2str(N), ' dk namench hodnot!!!'])
        case 2
            disp([' ', num2str(N), ' rows of measured values ', ...
                'written into file ', datsoubor, ' successfully!!!'])
    end
    disp(' ')
else
    switch jazyk
        case 1
            disp([' Zpis namench hodnot do souboru ', datsoubor, ...
                ' nebyl spn!!!'])
        case 2
            disp([' Writing of measured values into file ', datsoubor ...
                'was not successful!!!'])
    end
    return
end

%% Calculation of adiabatic compressibility of mixture
%  Vpoet adiabatick kompresibility smsi
kappas = 1./densSI./speed.^2;

molvol = molmassSI./densitySI;
kappas0 = [kappas(x1 == 1), kappas(x2 == 1), kappas(x3 == 1)];

for k = 1:N
    xk = x(k,1:3);
    xmolvol = xk.*molvol;
    volfrac = xmolvol/sum(xmolvol);
    kappasid(k,1) = ...
        sum(volfrac.*(kappas0+temp.*molvol.*thermexp.^2./heatcap))- ...
        temp*sum(xmolvol)*sum(volfrac.*thermexp)^2/sum(xk.*heatcap);
    kappasE(k,1) = kappas(k)-kappasid(k,1);
end

switch jazyk
    case 1
        disp(' Zpis vypotench dodatkovch adiabatickch kompresibilit')
        disp(' *********************************************************')
        disp(' ')
        disp(' Probh zpis dat do vstupn tabulky MS Excel!!!')
        disp(' ekejte, zpis dat me trvat nkolik destek vtein!!!')
    case 2
        disp(' Writing calculated excess adiabatic compressibilities')
        disp(' *****************************************************')
        disp(' ')
        disp(' Writing data to output MS Excel tables!!!')
        disp(' Wait, data writing may take tens of seconds!!!')
end

disp(' ')
[status, message] = xlswrite(datsoubor, 1e12*kappasE, SheetName3, 'F5');

if status == 1
    switch jazyk
        case 1
            disp([' Do souboru ', datsoubor, ' spn zapsno ', ...
                num2str(N), ' vsledk!!!'])
        case 2
            disp([' ', num2str(N), ' rows of measured values ', ...
                'written into file ', datsoubor, ' successfully!!!'])
    end
    disp(' ')
else
    switch jazyk
        case 1
            disp([' Zpis vsledk do souboru ', datsoubor, ' nebyl ', ...
                'spn!!!'])
        case 2
            disp([' Writing of results into file ', datsoubor ...
                'was not successful!!!'])
    end
    return
end


%% Displaying excess adiabatic compressibility calculated 
%  from experimental data
%  Zobrazen dodatkovch adiabatickch kompresibilit vypotench 
%  z experimentlnch dat

%  3D graph
%  Prostorov graf
nfig = nfig+1;
figure(nfig);

% Fig. No. 1
% Obr. . 1

normk = 10^(-round(log10(max(abs(kappasE)))));

kappasE_norm = normk*kappasE;
ternsurf(x1, x2, x3, kappasE_norm);

view([70, 20]);

text( 1.45, -0.23,  0.13, compname(1), 'HorizontalAlignment', 'Center', ...
    'FontSize', 12);
text( 0.98,  0.87,  0.17, compname(2), 'HorizontalAlignment', 'Right', ...
    'FontSize',12);
text(-0.24,  0.05, -0.03, compname(3), 'HorizontalAlignment', 'Left', ...
    'FontSize',12);
switch jazyk
    case 1
        texttitle = ['Dodatkov adiabatick kompresibilita vypoten ' ...
             'z experimentlnch dat / 10^{', ...
             num2str(log10(normk)), '} Pa^{-1}'];
        text(0.05, 0.70, 0.23, ...
            texttitle, 'HorizontalAlignment', 'Center');
    case 2
        texttitle = ['Excess adiabatic compressibility calculated ', ...
             'from experimental data / 10^{', ...
             num2str(log10(normk)), '} Pa^{-1}'];
        text(0.05, 0.70, 0.23, ...
            texttitle, 'HorizontalAlignment', 'Center');
end

colorbar('Location','EastOutside');
zoom(1.3)

%  Planar graph
%  Rovinn graf
nfig = nfig+1;
figure(nfig);

% Fig. No. 2
% Obr. . 2
ternsurf(x1, x2, x3, kappasE_norm);
text(0.5, -0.10, compname(1), 'HorizontalAlignment', 'Center', ...
    'FontSize', 12);
text(1.0,  0.55, compname(2), 'HorizontalAlignment', 'Right', ...
    'FontSize',12);
text(0.0,  0.55, compname(3), 'HorizontalAlignment', 'Left', ...
    'FontSize',12);
colorbar('Location','EastOutside');
switch jazyk
    case 1
        texttitle = ['Dodatkov adiabatick kompresibilita vypoten ' ...
             'z experimentlnch dat / 10^{', ...
             num2str(log10(normk)), '} Pa^{-1}'];
        title(texttitle, 'HorizontalAlignment', 'Center');
    case 2
        texttitle = ['Excess adiabatic compressibility calculated ', ...
             'from experimental data / 10^{', ...
             num2str(log10(normk)), '} Pa^{-1}'];
        title(texttitle, 'HorizontalAlignment', 'Center');
end

%% Setting optimization parameters
%  Method: fitting of experimental data using least square method
%  Function (Optimal Toolbox): lsqcurvefit
%  Nastaven optimalizanch parametr
%  Metoda: proloen plochy namenmi daty pomoc metody nejmench
%  tverc
%  Funkce (Optimal Toolbox): lsqcurvefit
OptCond = optimset('lsqcurvefit');
OptCond = optimset(OptCond,'Display','off','TolFun',2^(-0)*eps, ...
    'TolX',2^(-0)*eps);

%% Setting degrees for binary and ternary parts 
%  of Redlich-Kister equation
%  Nastaven stupn binrn sti a stupn ternrn sti
%  Redlich-Kisterovy rovnice
switch jazyk
    case 1
        disp(' Parametry modifikovan Redlich-Kisterovy rovnice')
        disp(' ************************************************')
        disp(' ')
        nbin = input([' Zadejte stupn binrnch st ', ...
            'Redlich-Kisterovy rovnice: '], 's');
    case 2
        disp(' Parameters of modified Redlich-Kister equation')
        disp(' **********************************************')
        disp(' ')
        nbin = input([' Enter degrees of Redlich-Kister equation ', ...
            'binary parts: '], 's');
end
nbin = str2num(nbin);
while isempty(nbin) | ~isnumeric(nbin) | ...
        (10-nbin)*nbin < 0 | nbin ~= fix(nbin)
    switch jazyk
        case 1
            disp([' Stupe mus bt cel slo mezi 0 a 10 vetn, ', ...
                'opakuj!!!'])
            disp(' ')
            nbin = input([' Zadejte stupn binrnch st ', ...
                'Redlich-Kisterovy rovnice: '], 's');
        case 2
            disp([' Degree must be integer between 0 and 10 ', ...
                'including, repeat!!!'])
            disp(' ')
            nbin = input([' Enter degrees of Redlich-Kister equation ', ...
                'binary parts: '], 's');
    end
    nbin = str2num(nbin);
end
switch jazyk
    case 1
        nter = input([' Zadejte stupe ternrn  sti Redlich-Kisterovy ', ...
            'rovnice: '], 's');
    case 2
        nter = input([' Enter degree  of Redlich-Kister equation ', ...
            'ternary part: '], 's');
end

nter = str2num(nter);
while isempty(nter) | ~isnumeric(nter) | ...
        (2-nter)*nter < 0 | nter ~= fix(nter)
    switch jazyk
        case 1
            disp(' Stupe mus bt cel slo mezi 0 a 2 vetn, opakuj!')
            disp(' ')
            nter = input([' Zadejte stupe ternrn  sti ', ...
                'Redlich-Kisterovy rovnice: '], 's');
        case 2
            nter = input([' Enter degree  of Redlich-Kister equation ', ...
                'ternar part: '], 's');
    end
    nter = str2num(nter);
end

%% Optimalizace
nn = 3*(nbin+1)+sum(1:nter+1);
a0 = ones(1,nn);
tStart=tic;
[a,ResNorm,Residual,ExitFlag,Output] = ...
    lsqcurvefit(@TernarRedlichKister,a0,x,kappasE_norm,[],[],OptCond);
tElapsed = toc(tStart);

% Results fitted by Redlich-Kister equation
% Vsledky vyrovnan pomoc Redlich-Kisterovy rovnice
kappasEcalc_norm = TernarRedlichKister(a,x);

% Progress and results of optimization
% Prbh a vsledky optimalizace
disp(' ')
switch jazyk
    case 1
        disp(' Prbh a vsledky optimalizace')
        disp(' ******************************')
    case 2
        disp(' Progress and results of optimization')
        disp(' ************************************')
end
disp(' ')
switch jazyk
    case 1
        fprintf(' Vsledky vyrovnn vypotench dat\n \n')
        fprintf(' Souet tverc odchylek : %10.4e  \n', ResNorm)
        fprintf(' Maximln odchylka      : %10.4e  \n', ...
            max(abs(kappasE_norm-kappasEcalc_norm)))
        fprintf(' Prmrn odchylka       : %10.4e  \n', ...
            mean(abs(kappasE_norm-kappasEcalc_norm)))
        fprintf(' Dosaen poet iterac  : %10d  \n', Output.iterations)
        fprintf(' Poet vyslen funkce  : %10d  \n', Output.funcCount)
    case 2
        fprintf(' Results of calculated data fitting \n')
        fprintf(' Sum of error squares          : %10.4e  \n', ResNorm)
        fprintf(' Maximum error                 : %10.4e  \n', ...
            max(abs(kappasE_norm-kappasEcalc_norm)))
        fprintf(' Average error                 : %10.4e  \n', ...
            mean(abs(kappasE_norm-kappasEcalc_norm)))
        fprintf(' Number of taken iterations    : %10d  \n', ...
            Output.iterations)
        fprintf(' Number of function evaluations: %10d  \n', ...
            Output.funcCount)
end
switch jazyk
    case 1
        switch ExitFlag
            case 4
                fprintf(['\n Optimum nalezeno spn za ',...
                    '%10.4f s!!!'], tElapsed)
                fprintf(['\n Norma smru vyhledvn je ', ...
                    'men ne ', '%10.4e !!! \n'], OptCond.TolX)
            case 3
                fprintf(['\n Optimum nalezeno spn za ', ...
                    '%10.4f s!!!'],tElapsed)
                    fprintf(['\n Zmna hodnoty elov funkce je ', ...
                    'men ne ', '%10.4e !!! \n'], OptCond.TolFun)
            case 2
            fprintf(['\n Optimum nalezeno spn za ', ...
                '%10.4f s!!!'], tElapsed)
            fprintf(['\n Zmna optimalizanch promnnch je ', ...
                'men ne ', '%10.4e !!! \n'], OptCond.TolX)
            case 1
                fprintf(['\n Optimum nalezeno spn za ', ...
                    '%10.4f s!!! \n'], tElapsed)
            case 0
                fprintf(['\n Pekroen maximln poet iterac ', ...
                    '%10d nebo'], OptCond.MaxIter)
                fprintf(['\n maximln poet vyslen funkce ', ...
                    '%10d !!! \n'], OptCond.MaxFunEvals)
            case -1
                disp(' Vpoet ukonen vstupn funkc!!!')
            case -2
                disp(' Problm nem ppustn een!!!')
            case -4
                disp(' Optimalizan proces neme dle pokraovat!!!')
        end
    case 2
        switch ExitFlag
            case 4
                fprintf(['\n Optimum reached successfully in ',...
                    '%10.4f s!!!'], tElapsed)
                fprintf(['\n Search direction norm is ', ...
                    'less than ', '%10.4e !!! \n'], OptCond.TolX)
            case 3
                fprintf(['\n Optimum reached successfully in ', ...
                    '%10.4f s!!!'], tElapsed)
                fprintf(['\n Change in goal function value is ', ...
                    'less than ', '%10.4e !!! \n'], OptCond.TolFun)
            case 2
                fprintf(['\n Optimum reached successfully in ', ...
                    '%10.4f s!!!'], tElapsed)
                fprintf(['\n Change in optimization variables is ', ...
                    'less than ', '%10.4e !!! \n'], OptCond.TolX)
            case 1
                fprintf(['\n Optimum reached successfully in ', ...
                    '%10.4f s!!! \n'], tElapsed)
            case 0
                fprintf(['\n Exceeded maximum number of iterations ', ...
                    '%10d nebo'], OptCond.MaxIter)
                fprintf(['\n maximum number of function evaluations ', ...
                    '%10d !!! \n'], OptCond.MaxFunEvals)
            case -1
                disp(' Optimization terminated by output function!!!')
            case -2
                disp(' Problem has no feasible solution!!!')
            case -4
                disp(' Optimization could not make further progress!!!')
        end
end
disp(' ')

%% Optimum coefficients of modified Redlich-Kister equations
%  Optimln koeficienty modifikovan Redlich-Kisterovy rovnice
switch jazyk
    case 1
        disp(' Nalezen koeficienty modifikovan Redlich-Kisterovy rovnice')
        disp(' ***********************************************************')
    case 2
        disp(' Optimum coefficients of modified Redlich-Kister equation')
        disp(' ********************************************************')
end
disp(' ')
koef = cell(nn,1);
for k = 1:3*(nbin+1)
    k1 = num2str(fix(k/(2*(nbin+1)+1))+1, '%1i');
    k2 = num2str(sign(fix(k/(nbin+2)))+2, '%1i');
    koef{k} = ['A(', k1, ',', k2, ')', num2str(mod(k-1,nbin+1))];
    disp([' ', koef{k}, ' = ', ...
        repmat(' ',1,(sign(a(k))+1)/2),num2str(a(k), '%10.6f')])
end
for k = 3*(nbin+1)+1:nn
    k1 = num2str(k-3*(nbin+1)-1, '%1i');
    koef{k} = ['B(', k1, ')'];
    disp([' ', koef{k}, '    = ', repmat(' ',1,(sign(a(k))+1)/2), ...
        num2str(a(k), '%10.6f')])
    
end
disp(' ')

%% Writing coefficients of modified Redlich-Kister equation
%  to MS Excel workbook
%  Zpis koeficient modifikovan Redlich-Kisterovy rovnice 
%  do seitu MS Excel
switch jazyk
    case 1
        disp(' Zpis koeficient modifikovan Redlich-Kisterovy rovnice')
        disp(' ********************************************************')
        disp(' ')
        disp(' Probh zpis koeficient do vstupn tabulky MS Excel!!!')
        disp(' ekejte, zpis dat me trvat nkolik destek vtein!!!')
    case 2
        disp(' Writing coefficients of modified Redlich-Kister equation')
        disp(' ********************************************************')
        disp(' ')
        disp([' Writing coefficients to output MS Excel workbook!!!'])
        disp(' Wait, data writing may take tens of seconds!!!')
end
disp(' ')
warning off MATLAB:xlswrite:AddSheet
switch jazyk
    case 1
        [status, message] = xlswrite(datsoubor, ...
            {'Koeficienty modifikovan Redlich-Kisterovy rovnice', '', '', ''; ...
             '', '','', ''; ...
            'stupe binrnch st', '', '', nbin; ...
            'stupe ternrn sti', '', '', nter}, ...
            SheetName4,'A1');
    case 2
        [status, message] = xlswrite(datsoubor, ...
            {'Coefficients of modified Redlich-Kister equation', '', '', ''; ...
             '', '','', ''; ...
            'binary parts degree', '', '', nbin; ...
            'ternary part degree', '', '',  nter}, ...
            SheetName4,'A1');
end

if strcmp(message.message,'Added specified worksheet.')
    switch jazyk
        case 1
            disp([' Do souboru ', datsoubor, ' pidn list ', ...
                'Koeficienty!!!'])
        case 2
            disp([' Coefficients worksheet added into file ', ...
                datsoubor, ' !!!'])
    end
    disp(' ')
end

[status1, message] = xlswrite(datsoubor, koef, SheetName4, 'A6');
[status2, message] = xlswrite(datsoubor, a', SheetName4, 'B6');
if status1 == 1 & status2 == 1
    switch jazyk
        case 1
            disp([' Do souboru ', datsoubor, ' spn zapsno ', ...
                num2str(nn), ' optimlnch koeficient Redlich-', ...
                'Kisterovy rovnice!!!'])
        case 2
            disp([' ', num2str(nn), ' optimum coefficients of Redlich-', ...
                'Kister equation successfully written to file ', ...
                datsoubor, ' !!!'])
    end
    disp(' ')
else
    switch jazyk
        case 1
            disp([' Zpis koeficient do souboru ', datsoubor, ...
                ' nebyl spn!!!'])
        case 2
            disp([' Writing of coefficients to file ', datsoubor ...
                'was not successful!!!'])
    end
    return
end

%% Writing of fitted excess adiabatic compressibilities
%  Zpis vyrovnanch dodatkovch adiabatickch kompresibilit
kappasEcalc = 1E+12/normk*kappasEcalc_norm;
switch jazyk
    case 1
        disp(' Zpis vyrovnanch dodatkovch objem')
        disp(' ************************************')
        disp(' ')
        disp(' Probh zpis dat do vstupn tabulky MS Excel!!!')
        disp(' ekejte, zpis dat me trvat nkolik destek vtein!!!')
    case 2
        disp(' Writing fitted excess volumes')
        disp(' *********************************')
        disp(' ')
        disp(' Writing data to output MS Excel tables!!!')
        disp(' Wait, data writing may take tens of seconds!!!')
end
disp(' ')
[status, message] = xlswrite(datsoubor,kappasEcalc,SheetName3,'G5');
if status == 1
    switch jazyk
        case 1
            disp([' Do souboru ', datsoubor, ' spn zapsno ', num2str(N), ...
                ' vsledk!!!'])
        case 2
            disp([' ', num2str(N), ' rows of measured values ', ...
                'written into file ', datsoubor, ' successfully!!!'])
    end
    disp(' ')
else
    switch jazyk
        case 1
            disp([' Zpis vsledk do souboru ', datsoubor, ' nebyl ', ...
                'spn!!!'])
        case 2
            disp([' Writing of results into file ', datsoubor ...
                'was not successful!!!'])
    end
    return
end

%% Comparison of results calculated from experimental data and
%  results fitted by Redlich-Kister equation
%  Srovnn vsledk vypotench z experimentlnch dat a
%  vsledk vyrovnanch pomoc Redlich-Kisterovy rovnice

% Graphical comparison of results
% Grafick srovnn vsledk
nfig = nfig+1;
figure(nfig);

% Fig. No. 3
% Obr. . 3
hold on
h1 = plot(kappasE_norm,kappasE_norm,'r');
Xlimits = xlim;
plot(linspace(Xlimits(1),Xlimits(2)),linspace(Xlimits(1),Xlimits(2)),'r')
delete(h1)
plot(kappasE_norm,kappasEcalc_norm,'b.')
switch jazyk
    case 1
        title(['Srovnn vypotench a vyrovnanch dodatkovch ', ...
            'adiabatickch kompresibilit'])
        xlabeltext = ['Vypoten dodatkov adiabatick kompresibilita ', ...
            '\kappa^E_S [10^{', num2str(log10(normk)), '} Pa^{-1}]'];
        xlabel(xlabeltext)
        ylabeltext = ['Vyrovnan dodatkov adiabatick kompresibilita ', ...
            '\kappa^E_S [10^{', num2str(log10(normk)), '} Pa^{-1}]'];
        ylabel(ylabeltext)
        legend('Vypoten data','Vyrovnan data','Location','Best')
    case 2
        title(['Comparison of calculated and fitted excess ', ...
            'adiabatic compressibilities']);
        xlabeltext = ['Calculated excess adiabatic compresibility ', ...
            '\kappa^E_S [10^{', num2str(log10(normk)), '} Pa^{-1}]'];
        xlabel(xlabeltext)
        ylabeltext = ['Fitted excess adiabatic compresibility ', ...
            '\kappa^E_S [10^{', num2str(log10(normk)), '} Pa^{-1}]'];
        ylabel(ylabeltext)
        legend('Calculated data','Fitted data','Location','Best')
end

%% Displaying excess adiabatic compressibilities
%  fitted by means of Redlich-Kister equation
%  Zobrazen dodatkovch adiabatickch kompresibilit
%  vyrovnanch pomoc Redlich-Kisterovy rovnice

% 3D graph
% Prostorov graf
nfig = nfig+1;
figure(nfig);

% Fig. No. 4
% Obr. . 4
ternsurf(x1, x2, x3, kappasEcalc_norm);

view([70, 20]);

text( 1.45, -0.23,  0.13, compname(1), 'HorizontalAlignment', 'Center', ...
    'FontSize', 12);
text( 0.98,  0.87,  0.17, compname(2), 'HorizontalAlignment', 'Right', ...
    'FontSize',12);
text(-0.24,  0.05, -0.03, compname(3), 'HorizontalAlignment', 'Left', ...
    'FontSize',12);
switch jazyk
    case 1
        texttitle = ['Dodatkov adiabatick kompresibilita vyrovnan ', ...
             'Redlich-Kisterovou rovnic / 10^{', ...
             num2str(log10(normk)), '} Pa^{-1}'];
        text(0.05, 0.70, 0.23, ...
            texttitle, 'HorizontalAlignment', 'Center');
    case 2
        texttitle = ['Excess adiabatic compressibility fitted ', ...
             'by Redlich-Kister equation / 10^{', ...
             num2str(log10(normk)), '} Pa^{-1}'];
        text(0.05, 0.70, 0.23, ...
            texttitle, 'HorizontalAlignment', 'Center');
end

colorbar('Location','EastOutside');
zoom(1.3)

return

